/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _MAIN_H
#define _MAIN_H

#include <Xm/Xm.h>

/*
 * Called from main() when the toplevel widget is created.
 */
char * getAppName (void);
char * getAppClass (void);

/*
 * Get any application specific resources.
 */
XrmOptionDescRec * getResourceDescriptions (int * num_desc);

/*
 * Create and manage the GL widget.
 */
Widget setupGLWidget (Widget parent);

/*
 * Create the sundry buttons and things on the desktop (other
 * than the gl widget.
 */
Widget setupDesktop (Widget parent, XtAppContext app_context);

/*
 * Actually manages the frame around the Gl widget.
 */
void showGLWidget (Widget parent);

/*
 * So that we don't need an app-defaults file.
 */
void setFallbackResources (XtAppContext app_context);

#endif
