/*
 * Copyright 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 * This file contains information used for cloning colors from
 * colors from the default X colormap to a copied colormap of the
 * appropriate depth for GL.  The following types determine how
 * to select the colors from the X colormap.
 */

#define GLXC_ABSOLUTE	0	/* use absolute pixel value */
#define GLXC_NAMED	1	/* look up by name */
#define GLXC_RESOURCE	2	/* lookup resource in parent widget */
    
/*
 * An array must be passed in of the following structure type, describing
 * the colors to be passed in.  The first three fields must be filled
 * in for each color, with the XColor being calculated.  Based on type,
 * value should be as follows:
 *
 *	type		value
 *	GLXC_ABSOLUTE	the pixel number to copy (e.g. 5)
 *	GLXC_NAMED	a color name (e.g. "red")
 *	GLXC_RESOURCE	a pixel resource name (e.g. XmNbackground)
 */

struct glxcColorInfo
{
    int type;		/* One of above types */
    caddr_t value;	/* based on above types */
    Colorindex *result;	/* store result in this variable */
    XColor color;	/* the xcolor definition */
};

