/*---*- C++ -*------------------------------------------------------------
 * $Id: Dialcode.h,v 2.6 1993/11/16 18:03:04 carlson Exp $
 *
 * Header file describing the Dialcode class.
 *
 * Revision History:
 *	$Log: Dialcode.h,v $
 * Revision 2.6  1993/11/16  18:03:04  carlson
 * Added support for modified flag.
 * Cleaned up some.
 *
 * Revision 2.5  1993/10/22  00:25:55  carlson
 * Added prototype for removeChangeCallback method.
 *
 * Revision 2.4  1993/10/18  19:58:45  carlson
 * Added prototype for dump method.
 *
 * Revision 2.3  1993/10/06  18:27:46  chris
 * Added declaration for method for outputing a line.
 * Changed all protected members to be private.
 *
 * Revision 2.2  1993/08/11  17:56:05  chris
 * Added methods for setting the script and adding callbacks.
 * Added callback capability for when the script is changed.
 *
 * Revision 2.1  1993/07/27  23:32:54  chris
 * Initial revision.
 * Broken out from Dialcodes.h.
 *
 *------------------------------------------------------------------------*/

#ifndef _DIALCODE_H_
#define _DIALCODE_H_

#include "linkList.h"

/*------------------------------------------------------------------------
 * Dialcode class
 *------------------------------------------------------------------------*/

class Dialcode;
class Dialcode : public LinkData
{
  public:
    typedef void (*callbackFunction)(Dialcode*, int, void*);

    Dialcode (const char *line);
    ~Dialcode ();

    const char*		script (void) { return code; }
    char*		line (void);

    void		setScript (char *ns);

    int			wasModified (void) { return modified; }
    void		clearModified (void) { modified = 0; }

    void		addChangeCallback (callbackFunction ncbf,
					   void *clientData);
    void		removeChangeCallback (callbackFunction ncbf,
					      void *clientData);

#ifdef DEBUG
    virtual void	dump (char *indent);
#endif

  private:
    char		*code;

    int			modified;

    struct callbackStruct
    {
	callbackFunction	cbf;
	void			*clientData;
	callbackStruct		*next;
    };
    callbackStruct	*callbacks;
};

#endif
