/*---*- C++ -*------------------------------------------------------------
 * $Id: DialcodeWindow.h,v 2.5 1993/11/16 18:39:50 carlson Exp $
 *
 * Header file for DialcodeWindow class.
 *
 * Revision History:
 *	$Log: DialcodeWindow.h,v $
 * Revision 2.5  1993/11/16  18:39:50  carlson
 * Somehow missed changing the include of linkList.h to SmartList.h.
 * Cleaned up some.
 *
 * Revision 2.4  1993/10/22  00:33:21  carlson
 * Added prototype for destructor.
 *
 * Revision 2.3  1993/10/18  19:58:46  carlson
 * Added prototype for dump method.
 *
 * Revision 2.2  1993/08/11  18:56:52  chris
 * Added methods to handle callbacks.
 *
 * Revision 2.1  1993/07/29  02:18:24  chris
 * Initial revision.
 *
 *------------------------------------------------------------------------*/

#ifndef _DIALCODEWINDOW_H_
#define _DIALCODEWINDOW_H_

#include <Vk/VkComponent.h>
#include "SmartList.h"

class Dialcode;

class DialcodeWindow : public VkComponent
{
  public:
    DialcodeWindow (Widget parent, Dialcode *dlr);
    ~DialcodeWindow ();

    virtual const char*	className () { return "DialcodeWindow"; }
#ifdef DEBUG
    virtual void	dump (char *indent);
#endif

  private:
    Dialcode		*dialcode;
    Widget		w_code;

    static void		dialcodeChangedCallback (Dialcode *, int, void *);
    static void		codeChangedCallback (Widget, XtPointer, XtPointer);

    void		dialcodeChanged (int, Dialcode *);
    void		codeChanged (XmAnyCallbackStruct *);
};

#endif
