/*---*- C++ -*------------------------------------------------------------
 * $Id: DialcodesSetup.h,v 2.1 1994/02/23 23:40:47 carlson Exp $
 *
 * Header file for DialcodesSetup class.
 *
 * Revision History:
 *	$Log: DialcodesSetup.h,v $
 * Revision 2.1  1994/02/23  23:40:47  carlson
 * Added callback prototypes for all the menu options.
 * Added place to keep track of current dialcode.
 *
 * Revision 1.1  1994/02/17  16:58:14  chrisc
 * Initial revision
 *
 *------------------------------------------------------------------------*/

#ifndef _DIALCODESSETUP_H_
#define _DIALCODESSETUP_H_

#include <Vk/VkWindow.h>
#include <Vk/VkMenu.h>
#include <Vk/VkSubMenu.h>

#include "PathName.h"
#include "Dialcodes.h"

class DialcodeWindow;
class Dialcode;

class DialcodesSetup : public VkWindow
{
  public:
    DialcodesSetup (PathName &file);
    ~DialcodesSetup ();

    void		save (void);
    int			wasModified (void) {
	return _dialcodes->wasModified (); }
    Dialcodes*		dialcodes (void) { return _dialcodes; }

    virtual const char*	className () { return "DialcodesSetup"; }
#ifdef DEBUG
    virtual void	dump (char *indent);
#endif

  protected:
    virtual Widget	setUpInterface (Widget parent);

  private:
    Dialcodes		*_dialcodes;
    Widget		dialcode_list;
    Widget		dialcode;
    DialcodeWindow	*current;
    Dialcode		*c_dlcd;
    VkSubMenu		*fileMenuPane;

    static void		selectCallback (Widget, XtPointer, XtPointer);
    static void		newCallback (Widget, XtPointer, XtPointer);
    static void		deleteCallback (Widget, XtPointer, XtPointer);
    static void		saveCallback (Widget, XtPointer, XtPointer);
    static void		printCallback (Widget, XtPointer, XtPointer);
    static void		quitCallback (Widget, XtPointer, XtPointer);
    static void		onWindowCallback (Widget, XtPointer, XtPointer);

    void		select_cb (char *text);
    void		new_cb ();
    void		delete_cb ();
    void		save_cb ();
    void		print_cb ();
    void		quit_cb ();
    void		onWindow_cb ();
};

#endif
