/*---*- C++ -*------------------------------------------------------------
 * $Id: DialerWindow.h,v 2.5 1993/11/16 18:52:09 carlson Exp $
 *
 * Header file for DialerWindow class.
 *
 * Revision History:
 *	$Log: DialerWindow.h,v $
 * Revision 2.5  1993/11/16  18:52:09  carlson
 * Somehow missed changing the include of linkList.h to SmartList.h.
 * Cleaned up some.
 *
 * Revision 2.4  1993/10/22  00:33:21  carlson
 * Added prototype for destructor.
 *
 * Revision 2.3  1993/10/14  23:45:23  carlson
 * Added prototype for dump method.
 *
 * Revision 2.2  1993/08/11  17:14:55  chris
 * Added prototypes for callbacks.
 * Changed description for Dialer class to include Dialer.h.
 *
 * Revision 2.1  1993/07/29  01:58:29  chris
 * Initial revision.
 *
 *------------------------------------------------------------------------*/

#ifndef _DIALERWINDOW_H_
#define _DIALERWINDOW_H_

#include <Vk/VkComponent.h>
#include "SmartList.h"
#include "Dialer.h"

class DialerWindow : public VkComponent
{
  public:
    DialerWindow (Widget parent, Dialer *dlr);
    ~DialerWindow ();

    virtual const char*	className () { return "DialerWindow"; }
#ifdef DEBUG
    virtual void	dump (char *indent);
#endif

  private:
    Dialer		*dialer;
    Widget		w_wait7;
    Widget		w_wait8;
    Widget		w_chat_script;

    static void		dialerChangedCallback (Dialer*, Dialer::Field, void *);
    static void		wait7ChangedCallback (Widget, XtPointer, XtPointer);
    static void		wait8ChangedCallback (Widget, XtPointer, XtPointer);
    static void		chatChangedCallback (Widget, XtPointer, XtPointer);

    void		dialerChanged (Dialer::Field, Dialer *);
    void		wait7Changed (XmAnyCallbackStruct *);
    void		wait8Changed (XmAnyCallbackStruct *);
    void		chatChanged (XmAnyCallbackStruct *);
};

#endif
