/*---*- C++ -*------------------------------------------------------------
 * $Id: HelpDialog.h,v 2.5 1994/02/08 20:52:53 chrisc Exp $
 *
 * Header file for the HelpDialog class.
 *
 * Revision History:
 *	$Log: HelpDialog.h,v $
 * Revision 2.5  1994/02/08  20:52:53  chrisc
 * Added prototype for a method for displaying an index of topics.
 *
 * Revision 2.4  1994/01/19  20:53:09  carlson
 * Added place to keep a file name.
 *
 * Revision 2.3  1993/11/11  21:16:41  carlson
 * Changed the symbol that keeps this from being included more than once.
 * Added definition for handleWmQuitMessage.
 *
 * Revision 2.2  1993/11/03  18:16:21  carlson
 * Added prototypes for 'theHelpDialog' and 'aHelpCallback'.
 *
 * Revision 2.1  1993/11/02  23:23:28  carlson
 * Revision lifted from vcal and modified for my use.
 *
 *------------------------------------------------------------------------*/

#ifndef _HELPDIALOG_H_
#define _HELPDIALOG_H_

#include <Vk/VkSimpleWindow.h>

class HelpDialog : public VkSimpleWindow {
  public:
    HelpDialog(const char *docName);
    ~HelpDialog() { }
    
    virtual const char* className() { return "HelpDialog"; }
    
    void		displayHelp (char *helpText);
    void		displayIndex (void);

  protected:
    virtual Widget	setUpInterface(Widget parent);
    virtual void	handleWmDeleteMessage();
    virtual void	handleWmQuitMessage();

  private:
    Widget		text;
    char		*fileName;
};

extern HelpDialog	*theHelpDialog;
extern void aHelpCallback (Widget, XtPointer, XtPointer);

#endif
