/*---*- C++ -*------------------------------------------------------------
 * $Id: ModemsWindow.h,v 2.3 1994/01/11 22:35:06 carlson Exp $
 *
 * Header file for Modems class.
 *
 * Revision History:
 *	$Log: ModemsWindow.h,v $
 * Revision 2.3  1994/01/11  22:35:06  carlson
 * Removed prototypes for handling Window manager messages.
 *
 * Revision 2.2  1994/01/06  01:23:09  carlson
 * Added prototype for destructor.
 * Added callbacks for select and edit.
 *
 * Revision 2.1  1994/01/05  02:31:30  carlson
 * Initial revision.
 *
 *------------------------------------------------------------------------*/

#include <Vk/VkSimpleWindow.h>

class EditModem;

class ModemsWindow : public VkSimpleWindow
{
  public:
    ModemsWindow (const char *name) : VkSimpleWindow (name) { }
    ~ModemsWindow ();

    virtual const char	*className () { return "ModemsWindow"; }

  protected:
    virtual Widget	setUpInterface (Widget parent);

  private:
    Widget		list;
    Widget		parentw;

    static void		selectCallback (Widget, XtPointer, XtPointer);
    static void		okCallback (Widget, XtPointer, XtPointer);
    static void		newCallback (Widget, XtPointer, XtPointer);
    static void		editCallback (Widget, XtPointer, XtPointer);
    static void		cancelCallback (Widget, XtPointer, XtPointer);

    void		select_cb (char *);
    void		ok_cb ();
    void		new_cb ();
    void		edit_cb ();
    void		cancel_cb ();
};
