/*---*- C++ -*------------------------------------------------------------
 * $Id: Registers.h,v 2.3 1994/01/12 00:40:46 carlson Exp $
 *
 * Header file for Registers class.
 *
 * Revision History:
 *	$Log: Registers.h,v $
 * Revision 2.3  1994/01/12  00:40:46  carlson
 * Added conditional compilation to avoid duplicate includes.
 *
 * Revision 2.2  1994/01/11  22:22:35  carlson
 * Added destructor.
 *
 * Revision 2.1  1994/01/08  01:05:08  carlson
 * Initial revision.
 *
 *------------------------------------------------------------------------*/

#ifndef _REGISTERS_H_
#define _REGISTERS_H_

#include "linkList.h"

class Registers : public LinkData
{
  public:
    enum Type {REGISTER, FLAG, NONE};

    Registers (char *tag, Type type, char *value = 0, char *doc = 0)
	: LinkData (tag) {_type = type; _value = value;
		      _documentation = doc;}
    Registers (const char *tag, Type type, char *value = 0, char *doc = 0)
	: LinkData (tag) {_type = type; _value = value;
		      _documentation = doc;}
    ~Registers ();

    Type		getType (void) { return _type; }
    char		*getValue (void) { return _value; }
    char		*getDocumentation (void) { return _documentation; }

    void		setType (Type type) { _type = type; }
    void		setValue (char *value) { _value = value; }
    void		setDocumentation (char *doc) { _documentation = doc; }

    void		appendDocumentation (char *doc, int crlf = 1);

  private:
    Type		_type;
    char		*_value;
    char		*_documentation;
};

#endif
