/*------------------------------------------------------------------------
 * $Id: Sequences.c++,v 2.2 1994/01/11 22:23:15 carlson Exp $
 *
 * Methods for Sequences class.
 *
 * Revision History:
 *	$Log: Sequences.c++,v $
// Revision 2.2  1994/01/11  22:23:15  carlson
// Added destructor that will also delete allocated variables.
//
// Revision 2.1  1994/01/10  20:10:42  carlson
// Initial revision.
//
 *------------------------------------------------------------------------*/

#include "Sequences.h"
#include <string.h>

/*------------------------------------------------------------------------
 * Sequences::appendDocumentation (char *, int)
 *------------------------------------------------------------------------*/

void Sequences::appendDocumentation (char *doc, int crlf)
{
    char		*newStr;

    if (_documentation)
    {
	newStr = new char [strlen (_documentation) + strlen (doc) + 2];
	strcpy (newStr, _documentation);
	if (crlf)
	    strcat (newStr, "\n");
	strcat (newStr, doc);
	delete [] _documentation;
    }
    else
    {
	newStr = new char [strlen (doc) + 1];
	strcpy (newStr, doc);
    }
    _documentation = newStr;
}

/*------------------------------------------------------------------------
 * Sequences::~Sequences ()
 *------------------------------------------------------------------------*/

Sequences::~Sequences ()
{
    if (_send)
	delete [] _send;
    if (_expect)
	delete [] _expect;
    if (_documentation)
	delete [] _documentation;
}
