/*---*- C++ -*------------------------------------------------------------
 * $Id: Sequences.h,v 2.3 1994/01/12 00:40:46 carlson Exp $
 *
 * Header file for Sequences class.
 *
 * Revision History:
 *	$Log: Sequences.h,v $
 * Revision 2.3  1994/01/12  00:40:46  carlson
 * Added conditional compilation to avoid duplicate includes.
 *
 * Revision 2.2  1994/01/11  22:22:36  carlson
 * Added destructor.
 *
 * Revision 2.1  1994/01/10  20:10:42  carlson
 * Initial revision.
 *
 *------------------------------------------------------------------------*/

#ifndef _SEQUENCES_H_
#define _SEQUENCES_H_

#include "linkList.h"

class Sequences : public LinkData
{
  public:
    Sequences (char *tag, char *send = 0, char *expect = 0, char *doc = 0)
	: LinkData (tag) { _send = send; _expect = expect;
			   _documentation = doc; }
    Sequences (const char *tag, char *send = 0, char *expect = 0,
	       char *doc = 0)
	: LinkData (tag) { _send = send; _expect = expect;
			   _documentation = doc; }
    ~Sequences ();

    char		*getSend (void) { return _send; }
    char		*getExpect (void) { return _expect; }
    char		*getDocumentation (void) { return _documentation; }

    void		setSend (char *send) { _send = send; }
    void		setExpect (char *expect) { _expect = expect; }
    void		setDocumentation (char *doc) { _documentation = doc; }

    void		appendDocumentation (char *doc, int crlf = 1);

  private:
    char		*_send;
    char		*_expect;
    char		*_documentation;
};

#endif
