/*---*- C++ -*------------------------------------------------------------
 * $Id: Tutorial.h,v 2.2 1993/12/30 02:10:14 carlson Exp $
 *
 * Header file for tutorial class.
 *
 * Revision History:
 *	$Log: Tutorial.h,v $
 * Revision 2.2  1993/12/30  02:10:14  carlson
 * Removed unused method displayTutorial.
 * Added method to append text.
 *
 * Revision 2.1  1993/12/29  21:34:52  carlson
 * Initial revision.
 *
 *------------------------------------------------------------------------*/

#include <Vk/VkWindow.h>
#include <Vk/VkMenu.h>
#include <Vk/VkSubMenu.h>
#include <fstream.h>

class Tutorial;

class Tutorial : public VkWindow
{
    struct CallbackData
    {
	int		step;
	Tutorial	*me;
    };

  public:
    Tutorial (const char *name) : VkWindow (name) { }
    ~Tutorial () { }

    virtual const char	*className () { return "Tutorial"; }

  protected:
    virtual Widget	setUpInterface (Widget parent);
    virtual void	handleWmDeleteMessage ();
    virtual void	handleWmQuitMessage ();

  private:
    Widget		text;
    Widget		command;
    Widget		next_button;
    Widget		prev_button;
    VkSubMenu		*stepMenuPane;
    ifstream		*tutorial_file;
    int			total_steps;
    streampos		*step_positions;
    int			current_step;

    void		showStep (int);
    void		appendText (char *, Boolean);

    static void		stepCallback (Widget, XtPointer, XtPointer);
    static void		nextCallback (Widget, XtPointer, XtPointer);
    static void		prevCallback (Widget, XtPointer, XtPointer);
    static void		quitCallback (Widget, XtPointer, XtPointer);

    void		step_cb (int step);
    void		next_cb ();
    void		prev_cb ();
    void		quit_cb ();
};
