/*------------------------------------------------------------------------
 * $Id: VkSelectionDialog.c++,v 2.4 1994/02/08 20:53:59 chrisc Exp $
 *
 * Methods for the selection dialog following the ViewKit format.
 *
 * Revision History:
 *	$Log: VkSelectionDialog.c++,v $
// Revision 2.4  1994/02/08  20:53:59  chrisc
// Removed commented out code.
// Try removing code that I think is redundant.
// Completed method for returning the selected item.
//
// Revision 2.3  1993/10/07  20:58:04  carlson
// Removed code that was commented out anyway.
//
// Revision 2.2  1993/07/07  23:59:50  chris
// Missed commenting out one print statement.
//
// Revision 2.1  1993/07/07  17:22:42  chris
// Using ifdefs, commented out write statements.
// Set the list each time dialog is posted.
//
// Revision 1.1  1993/05/14  07:30:07  chris
// Initial revision
//
 *------------------------------------------------------------------------*/

#include "VkSelectionDialog.h"

#include <Xm/SelectioB.h>

#include <iostream.h>

VkSelectionDialog	*theSelectionDialog =
			new VkSelectionDialog ("theSelectionDialog");

/*------------------------------------------------------------------------
 * ~VkSelectionDialog
 *------------------------------------------------------------------------*/

VkSelectionDialog::~VkSelectionDialog ()
{
    XtDestroyWidget (_baseWidget);
    _baseWidget = NULL;
}

/*------------------------------------------------------------------------
 * createDialog
 *------------------------------------------------------------------------*/

Widget VkSelectionDialog::createDialog (Widget parent)
{
    Widget		dialog;

#ifdef DEBUG1
    cout << "createDialog called\n" << flush;
#endif

    dialog = XmCreateSelectionDialog (parent, "theSelectionDialog",
				      NULL, 0);
    _allowMultipleDialogs = True;

#if 0
    if (selList)
	XtVaSetValues (dialog, XmNlistItems, selList,
		       XmNlistItemCount, selList_size,
		       XmNmustMatch, _mustMatch, NULL);
#endif

#ifdef DEBUG1
    cout << "    dialog widget is " << hex << dialog << "\n" << flush;
#endif

    return dialog;
}

/*------------------------------------------------------------------------
 * Possible virtual methods:
 *	prepost
 *	findDialog
 *	ok
 *	cancel
 *	apply
 *	~VkDialogManager
 *	hide
 *	show
 *	post
 *	postModal
 *	postBlocked
 *	postAndWait
 *------------------------------------------------------------------------*/

/*------------------------------------------------------------------------
 * setList
 *------------------------------------------------------------------------*/

void VkSelectionDialog::setList (char **list)
{
    int		i;

#ifdef DEBUG1
    cout << "setList called\n" << flush;
#endif

    if (selList)
    {
	for (i = 0; i < selList_size; i++)
	    XmStringFree (selList[i]);
	delete [] selList;
    }

    for (selList_size = 0; list[selList_size]; selList_size++);

    selList = new XmString [selList_size];

    for (i = 0; i < selList_size; i++)
    {
	selList[i] = XmStringCreate (list[i], XmFONTLIST_DEFAULT_TAG);
    }
}

/*------------------------------------------------------------------------
 * getSelection
 *------------------------------------------------------------------------*/

char *VkSelectionDialog::getSelection (void)
{
    XmString		xmstr;
    char		*str;

    XtVaGetValues (_baseWidget, XmNtextString, &xmstr, NULL);

    XmStringGetLtoR (xmstr, XmFONTLIST_DEFAULT_TAG, &str);

    return str;
}

/*------------------------------------------------------------------------
 * prepost
 *------------------------------------------------------------------------*/

Widget VkSelectionDialog::prepost (const char	 *message,
				   XtCallbackProc okCB,
				   XtCallbackProc cancelCB,
				   XtCallbackProc applyCB,
				   void		 *clientData,
				   const char	 *helpString,
				   VkSimpleWindow *parent)
{
    Widget		w;

#ifdef DEBUG1
    cout << "prepost called\n" << flush;
#endif

    w = VkDialogManager::prepost (message, okCB, cancelCB, applyCB,
				  clientData, helpString, parent);

#ifdef DEBUG1
    cout << "    Widget returned is " << hex << w << "\n" << flush;
#endif

    if (selList)
	XtVaSetValues (w, XmNlistItems, selList,
		       XmNlistItemCount, selList_size, NULL);

    XtVaSetValues (w, XmNmustMatch, _mustMatch, NULL);

    return w;
}
