/*---*- C++ -*------------------------------------------------------------
 * $Id: VkSelectionDialog.h,v 2.1 1993/10/07 20:51:26 carlson Exp $
 *
 * Header file for a selection dialog following the ViewKit format.
 *
 * Revision History:
 *	$Log: VkSelectionDialog.h,v $
 * Revision 2.1  1993/10/07  20:51:26  carlson
 * Removed commented out code and lined things up the way I do in other
 *   files.
 *
 * Revision 1.1  1993/05/14  07:26:08  chris
 * Initial revision
 *
 *------------------------------------------------------------------------*/

#ifndef VKSELECTIONDIALOG_H
#define VKSELECTIONDIALOG_H

#include <Vk/VkDialogManager.h>

class VkSelectionDialog : public VkDialogManager
{
  public:
    VkSelectionDialog (const char *name) : VkDialogManager (name) {
	selList = NULL;
	selList_size = 0;
	_mustMatch = False;
    }
    ~VkSelectionDialog ();

    void		setList (char **list);
    void		mustMatch (Boolean tf) { _mustMatch = tf; }
    char		*getSelection (void);

  protected:
    virtual Widget	createDialog (Widget w);
    virtual Widget	prepost (const char	 *message,
				 XtCallbackProc okCB = NULL,
				 XtCallbackProc cancelCB = NULL,
				 XtCallbackProc applyCB = NULL,
				 void		 *clientData = NULL,
				 const char	 *helpString = NULL,
				 VkSimpleWindow *parent = NULL);

  private:
    XmString		*selList;
    int			selList_size;
    Boolean		_mustMatch;
};

extern VkSelectionDialog	*theSelectionDialog;

#endif
