/*---*- C++ -*------------------------------------------------------------
 * $Id: linkEntry.h,v 2.1 1994/01/17 20:29:12 carlson Exp $
 *
 * Header file for the LinkEntry class.
 *
 * Documentation:
 *	This class is used by the LinkList class but is not required
 *	outside of it.
 *
 * Revision History:
 *	$Log: linkEntry.h,v $
 * Revision 2.1  1994/01/17  20:29:12  carlson
 * Initial revision.
 *
 * Revision 1.1  94/01/15  08:20:26  ROOT_DOS
 * Initial revision
 * 
 *------------------------------------------------------------------------*/

class LinkData;
class LinkList;

class LinkEntry
{
friend	LinkList;
  public:
    LinkEntry (LinkData *value) { data = value; f = 0; next = 0; }
    ~LinkEntry () { }

    const char*		key (void) { return data->theKey (); }
    LinkData*		Data (void) { return data; }
    LinkEntry*		Next (void) { return next; }
    int			flag (void) { return f; }
    void		setFlag (int v) { f = v; }
    void		append (LinkEntry *l) {
	if (next)
	    next->append (l);
	else
	    next = l;
    }
    virtual void	deleteData (void) {
	if (data)
	    delete data;
    }

  protected:
    LinkData		*data;
    int			f;	// Flags for general use
    LinkEntry		*next;
};
