/*---*- C++ -*------------------------------------------------------------
 * $Id: systemfiles.h,v 2.4 1994/01/14 02:14:20 carlson Exp $
 *
 * Header file which is common to all the classes which access the
 * system files.
 *
 * Revision History:
 *	$Log: systemfiles.h,v $
 * Revision 2.4  1994/01/14  02:14:20  carlson
 * Added prototypes for convert_string, parse_string and unparse_string.
 *
 * Revision 2.3  1994/01/12  21:56:45  carlson
 * Added the prototype for XtClassName.
 *
 * Revision 2.2  1994/01/12  00:47:40  carlson
 * Copy now gets a constant char string.
 *
 * Revision 2.1  1993/11/16  17:58:20  carlson
 * Made this a header file for systemfiles.c++.
 *
 * Revision 1.1  1993/05/05  19:33:41  chris
 * Initial revision
 *
 *------------------------------------------------------------------------*/

#ifndef _SYSTEMFILES_H_
#define _SYSTEMFILES_H_

#include <fstream.h>

#include <X11/Intrinsic.h>

extern char *read_line (ifstream *file);
extern char *Copy (const char *from);
extern char *gettoken (char **string, char *delims);
extern char *get_line (ifstream *file);
extern char *XtClassName (Widget);
extern char *convert_string (char *);
extern char *parse_string (char *);
extern char *unparse_string (char *);

#endif
