/*---*- C++ -*------------------------------------------------------------
 * $Id: uucp.h,v 2.5 1994/02/15 04:30:39 chrisc Exp $
 *
 * Header file for uucp visual admin program.
 *
 * Revision History:
 *	$Log: uucp.h,v $
 * Revision 2.5  1994/02/15  04:30:39  chrisc
 * Changed all references to myApplication to refer to uucpApplication.
 * Added methods to support maintaining the dialcodes file information.
 *
 * Revision 2.4  1994/02/10  21:31:45  chrisc
 * Added variables and methods to retrieve the values for the UUCP directory
 *   and the help file name.
 *
 * Revision 2.3  1994/01/05  18:16:27  carlson
 * Removed include of limits.h, not used.
 *
 * Revision 2.2  1994/01/05  00:49:19  carlson
 * Added variables to hold directory and tutorial file name.
 * Created methods to retrieve these items.
 * Provide extern for my application class.
 *
 * Revision 2.1  1993/12/29  00:00:04  carlson
 * Added definition for MyApp class.
 *
 * Revision 1.2  1993/05/07  00:22:33  chris
 * Fixed so it automatically comes up in c++-mode for Emacs.
 *
 * Revision 1.1  1993/03/25  06:16:24  chris
 * Initial revision
 *
 *----------------------------------------------------------------------*/

#include <Vk/VkApp.h>
#include "SmartList.h"

class UUCPApp : public VkApp
{
  public:
    UUCPApp (char		    *appClassName,
	     int		    *arg_c,
	     char		    **arg_v,
	     XrmOptionDescRec	    *optionList = NULL,
	     int		    sizeOfOptionList = 0);

    void		setDialcodes (SmartList *dialcodes)
				{ _dialcodes = dialcodes; }

    Boolean		verbosity (void) { return _verbose; }
    char		*directory (void) { return _directory; }
    char		*tutorial (void) { return _tutorial; }
    char		*uucpDirectory (void) { return _uucpDirectory; }
    char		*helpFile (void) { return _helpFile; }
    SmartList		*dialcodes (void) { return _dialcodes; }

  protected:
    Boolean		_verbose;
    char		*_directory;
    char		*_tutorial;
    char		*_uucpDirectory;
    char		*_helpFile;

  private:
    SmartList		*_dialcodes;

    static String	defaultRes[];
    static XtResource	_resources[];
};

extern UUCPApp *uucpApplication;
