/*
 * Copyright (c) 1993, 1994 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that (i) the above copyright notices and this
 * permission notice appear in all copies of the software and related
 * documentation, and (ii) the name of Silicon Graphics may not be
 * used in any advertising or publicity relating to the software
 * without the specific, prior written permission of Silicon Graphics.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#include <stdio.h>
#include <invent.h>
#include <gl.h>

/* XXX - hack for different INV_ names */
#ifndef INV_RE
#define INV_RE INV_VENICE
#endif

/* XXX for pre-4.0.5H (pre-fullhouse) invent.h */
#ifndef INV_GU1_EXTREME
#define INV_GR3_XSM     0x44    /* GR3-XSM */
#define INV_GR3_ELAN    0x47    /* GR3-Elan */
#define INV_GU1_EXTREME 0xa3    /* GU1-Extreme */
#endif

/* XXX for pre-4.0.5H (pre-Indy) invent.h */
#ifndef INV_NEWPORT
#define INV_NEWPORT     14      /* Newport graphics */
/* States for graphics class NEWPORT */
#define INV_NEWPORT_XL  0x01    /* Indigo2 XL model */
#define INV_NEWPORT_24  0x02    /* board has 24 bitplanes */
#endif

#ifdef IRIX4
#define INV_TYPE type
#define INV_CLASS class
#define INV_STATE state
#else
#define INV_TYPE inv_type
#define INV_CLASS inv_class
#define INV_STATE inv_state
#endif

#ifndef INV_VTX                 /* XXX - should be in sys/invent.h */
#define INV_VTX         13
#endif



#define PFGFX_VSYNC             0x00000001
#define PFGFX_FAST_TEX          0x00000002
#define PFGFX_MSAMPLE           0x00000004
#define PFGFX_SPLINE_FOG        0x00000008
#define PFGFX_DETAIL_TEX        0x00000010
#define PFGFX_AFUNC_ALL         0x00000020
#define PFGFX_PIPE_TIMES        0x00000040
#define PFGFX_DISPLACE          0x00000080
#define PFGFX_USE_DISPLACE      0x00000100
#define PFGFX_USE_MM_TRILINEAR  0x00000200
#define PFGFX_IS_TEX_LOADED     0x00000400
#define PFGFX_MS_LPOINT         0x00001000
#define PFGFX_GANGDRAW          0x00002000
#define PFGFX_SKYWRITER         0x00004000
#define PFGFX_ZWRAP_BUG         0x00010000
#define PFGFX_HPC_30NS          0x00020000
#define PFGFX_HPC_33NS          0x00040000
#define PFGFX_HPC_40NS          0x00080000
#define PFGFX_MEM_SHIFT         20
#define PFGFX_MEM_MASK          0xfff00000

long uGetGfxType( void );

extern long _GfxType;

#define UGET_GFX_TYPE() ( _GfxType >= 0 ? _GfxType : uGetGfxType())

