/* --------------------------------------------------------- */
/* | Copyright (c) 1986, 1989 MIPS Computer Systems, Inc.  | */
/* | All Rights Reserved.                                  | */
/* --------------------------------------------------------- */

/*
 * pfsqrt.s - fast square root lifted from libm.a
 *
 * $Revision: 1.14 $
 * $Date: 1993/09/15 04:31:32 $
 *
 */

/* 1-lsb accurate sqrt, much faster than libm version. */

#include <regdef.h>

.rdata
fnan:
	.word 0x7f800001
_pfsqrttable:
	.word 83599<<3
	.word 71378<<3
	.word 60428<<3
	.word 50647<<3
	.word 41945<<3
	.word 34246<<3
	.word 27478<<3
	.word 21581<<3
	.word 16499<<3
	.word 12183<<3
	.word 8588<<3
	.word 5674<<3
	.word 3403<<3
	.word 1742<<3
	.word 661<<3
	.word 130<<3
	.word 0<<3
	.word 1204<<3
	.word 3062<<3
	.word 5746<<3
	.word 9193<<3
	.word 13348<<3
	.word 18162<<3
	.word 23592<<3
	.word 29598<<3
	.word 36145<<3
	.word 43202<<3
	.word 50740<<3
	.word 58733<<3
	.word 67158<<3
	.word 75992<<3
	.word 85215<<3

.text

.globl pfSqrt
.ent pfSqrt
pfSqrt:
	.frame	sp, 0, ra
#ifdef DSO
	.set noreorder
	.cpload t9
	.set reorder
#endif
	mfc1	t0, $f12
	li	t2, -(127<<22)+(127<<23)
	sra	t1, t0, 23
	li	t3, 255
	blez	t1, 8f
	srl	t0, 1
	beq	t1, t3, 9f
	srl	t1, t0, 18-2
	and	t1, 31<<2
	lw	t1, _pfsqrttable(t1)
	addu	t0, t2
	subu	t0, t1
	mtc1	t0, $f0

	/* 8 -> 18 bits */
	li	t2, (1<<23)
	div.s	$f2, $f12, $f0
	/* 10 cycle interlock */
	add.s	$f0, $f2
	/* 1 cycle interlock (2 cycle stall) */
	mfc1	t0, $f0
	add	t1, t2, 6<<3	/* 17 -> 18 bits */
	subu	t0, t1
	mtc1	t0, $f0
	/* nop */

	/* 18 -> 37 */
	div.s	$f2, $f12, $f0
	/* 10 cycle interlock */
	add.s	$f0, $f2
	/* 1 cycle interlock (2 cycle stall) */
	mfc1	t0, $f0
	/* nop */
	subu	t0, t2
	mtc1	t0, $f0
	j	ra

8:	/* sign = 1 or biased exponent = 0 */
	sll	t2, t0, 1
	bne	t2, 0, 1f
9:	/* x = 0.0, -0.0, or +inf */
	mov.s	$f0, $f12
	j	ra
1:	/* x < 0 or x = _pfdenorm */
	lwc1	$f0, fnan
	j	ra
	/* nop */
.end pfSqrt
