/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 * texstate.h
 *
 * $Revision: 1.26 $
 * 
*/

#ifndef __TEXSTATE__
#define __TEXSTATE__

#include "image.h" 

#ifndef _MAXSTRING
#define _MAXSTRING 1025
#endif
#ifndef MAXPROPS
#define MAXPROPS 129
#endif

#define UTX_SHARPEN_SPLINE 2
#define UTX_DETAIL_SPLINE  3


typedef struct _uTexture {
    /*prObject	    obj;*/
    long            index;	/* unique descriptor */
    long            dirty;	/* for changes after binding */
    long            sx, sy, sz;
    long            comp;
    unsigned long  *image;
    char	    *name;
    long            magfilter, alphamag, colormag;
    long            minfilter;
    long	    intformat, extformat, fastdefine;
    long            wrap, twrap, swrap, rwrap;
    struct _uTexture *detail;
    long	    dprops[5];
    uVec2	    sharpspline[4];
    float	    sharpclamp;
    uVec2	    detailspline[4];
    float	    detailclamp;
    long	    freeimg;
} uTexture;

typedef struct _uTexEnv {
    /*prObject	    obj; */
    long	    index;
    long	    dirty;      /* for changes after binding */
    long	    mode;
    uVec4	    blend;
    long	    compsel;	/* Component select */
} uTexEnv;

long	  uBuildTex(uTexture *tex, char path[_MAXSTRING], IMAGE *image_in);
uTexture* uNewTex( void );
void      uTexName(uTexture *tex, char *name);
long      uLoadTexFile(uTexture *tex, char *name);
void      uTexRepeat(uTexture *tex, long wrap, long type);
uTexEnv*  uNewTEnv(void);
void      uApplyTEnv(uTexEnv * tev);


#ifdef can_do_this
extern void 	_pfApplyTex(uTexture*);
extern void 	_pfIdleTex(uTexture*);
extern void 	_pfCopyTex(uTexture*, uTexture*);
extern void 	_pfDelTex(uTexture*);
extern void 	_pfApplyTEnv(uTexEnv*);
extern void 	_pfCopyTEnv(uTexEnv*, uTexEnv*);
#endif


#endif
