/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/param.h>

#include "ufctimes.h"

#define float double

int first_time=1;

clock_t real_time =0,rt1,rt2;

struct tms bfr0,bfr1,bfr2;

void ftimes_(void) 
{
  real_time = times(&bfr0);

  if(first_time == 1) {
     memcpy(&bfr1,&bfr0,(sizeof (long))*4);
     rt1 = real_time;
     first_time = 0;
  } else if (first_time == 0) {
     memcpy(&bfr2,&bfr0,(sizeof (long))*4);
     rt2 = real_time;
     first_time = -1;
  }
}

#include <unistd.h>

void printtimes_( int *type ) /* mask of sums to be printed */
{
   float Hz = (float)sysconf(_SC_CLK_TCK);
   if(first_time == -1) {
      if(*type & FC_TICKS) 
	   printf("clock ticks elapsed: %d\n", (rt2-rt1));
      if(*type & FC_RTIME) 
	   printf("REAL time elapsed: %E\n",
			   (float)(rt2-rt1)/Hz);
      if(*type & FC_UTIME) 
	   printf("USER time elapsed: %E\n",
			   (float)(bfr2.tms_utime-bfr1.tms_utime)/Hz);
      if(*type & FC_STIME) 
	   printf("SYSTEM time elapsed: %E\n",
			   (float)(bfr2.tms_stime-bfr1.tms_stime)/Hz);
      if(*type & FC_CUTIME) 
	   printf("COMBINED-USER time elapsed: %E\n",
			   (float)(bfr2.tms_cutime-bfr1.tms_cutime)/Hz);
      if(*type & FC_CSTIME) 
	   printf("COMBINED-SYSTEM time elapsed: %E\n",
			   (float)(bfr2.tms_cstime-bfr1.tms_cstime)/Hz);
      first_time = 1;
   } else {
      fprintf(stderr,"must call `ftimes` twice...\n");
   }
}

/* c-interface */
void smartTime(void)
{
   ftimes_();
}

void printTime( int type ) /* mask of sums to be printed */
{
   printtimes_(&type);
}

#include "getgfxtype.h"

float warp_factor=1.0;
static float my_real_time;
static int my_first_time=1;
double uGetTime(void)
{
   first_time = -1;
   ftimes_();
   if(my_first_time) {
      my_real_time = real_time;
      my_first_time = 0;
   }
   first_time = -1;
   return((double)((real_time-my_real_time)/(double)sysconf(_SC_CLK_TCK))/warp_factor);
}

void uResetTime( void )
{
   my_real_time =0.0;
   my_first_time = 1;   
}
