/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _ENTRY_DIALOG_
#define _ENTRY_DIALOG_

#include <Vk/VkPrefDialog.h>

class Entry;
class VkPrefList;
class VkPrefLabel;
class VkPrefGroup;
class VkPrefToggle;
class VkPrefSeparator;
class VkPrefOption;
class VkPrefText;
class DayView;

class EntryDialog : public VkPrefDialog {
  
public:
  
  EntryDialog(Entry *entry, DayView *owner, const char *name);
  ~EntryDialog();
  Entry *entry() { return _entry; }
  
protected:
  
  virtual void apply(Widget, XtPointer);
  virtual Widget createDialog(Widget parent);  
  void updateDisplay();
  Boolean doApply();
  void newKind(Widget w);

private:

  static void kind_stub(Widget w, XtPointer client_data, XtPointer call_data);
  
  VkPrefList *list;
  VkPrefLabel *label;
  VkPrefSeparator *separator;
  VkPrefGroup *group;
  VkPrefOption *kind;
  VkPrefToggle *annotate;
  VkPrefToggle *notifyPopup, *notifyBell, *notifyMail;
  VkPrefText *notifyCommand;
  VkPrefText *advance, *repeat;
  DayView *owner;
  Entry *_entry;
};

#endif








