/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <stdio.h>
#include <string.h>
#include <Vk/VkHelp.h>
#include <Vk/VkApp.h>
#include "HelpDialog.h"

HelpDialog *helpDialog = NULL;

typedef struct {
  char *key;
  char *topic;
} KeyInfo;

static KeyInfo keys[] = {
  { "popup_popupMenu.overview", "Month View" },
  { "vcal.overview", "Month View" },
  { "dayView.overview", "Day View" },
  { "monthOverview.overview", "Month Overview" },
  { "weekOverview.overview", "Week Overview" },
  { "prefDialog", "Preferences" },
  { "entryAttrDialog", "Entry Attributes" },
};

extern "C" {

int SGIHelpInit(Display *, char *, char *)
{
  return 1;
}

int SGIHelpMsg(char *key, char *, char *)
{
  int each;

  theApplication->busy();
  if (!helpDialog) {
    helpDialog = new HelpDialog("helpDialog");
  }
  helpDialog->show();
  if (key) {
    for (each=0; each<XtNumber(keys); each++) {
      if (!strcmp(keys[each].key, key)) {
	helpDialog->topicSelect(keys[each].topic);
	break;
      }
    }
  }
  helpDialog->open();
  helpDialog->raise();
  theApplication->notBusy();
  return 1;
}

int SGIHelpIndexMsg(char *key, char *)
{
  SGIHelpMsg(key, NULL, NULL);
  return 1;
}

}
