/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _HELP_DIALOG_
#define _HELP_DIALOG_

#include <Vk/VkSimpleWindow.h>

typedef struct {
  char *topic;
  int offset;
} HelpIndexInfo;

class HelpDialog : public VkSimpleWindow {
public:
  HelpDialog(const char *docName);
  ~HelpDialog();

  virtual const char* className();
  void topicSelect(char *topic);

protected:
  virtual Widget setUpInterface(Widget parent);
  virtual void handleWmDeleteMessage();

  void displayHelp();
  void createIndex();
  void addIndex(char *topic, int offset);
  void topicSelect(int index);

  static void topic_select(Widget w, XtPointer clientData, XtPointer callData);

  Widget form, text, label, list;
  int numInfo;
  HelpIndexInfo *info;
};

#endif
