/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _MONTH_OVERVIEW_
#define _MONTH_OVERVIEW_

#include <Vk/VkWindow.h>

class VCal;
class OverviewDay;

#define NUM_SPOTS	42

class MonthOverview : public VkWindow {
public:
  MonthOverview(VCal *owner, const char *docName);
  ~MonthOverview();

  const char *className();

  void selectMonth(int month, int year);
  void updateDisplay() { selectMonth(month, year); }

protected:
  virtual Widget setUpInterface(Widget parent);
  virtual void handleWmDeleteMessage();
  void fileMenu();
  void doQuit();
  void restrictedChanged(Boolean restricted);

  static void quit_menu(Widget w, XtPointer client_data, XtPointer call_data);
  static void restricted_menu(Widget w, XtPointer client_data,
			      XtPointer call_data);

  VCal *owner;
  Widget form, grid, monthLabel;
  OverviewDay *days[NUM_SPOTS];
  int month, year;
  Boolean restricted;
};

#endif
