/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _OVERVIEW_DAY_
#define _OVERVIEW_DAY_

#include <Vk/VkComponent.h>
#include "Utils.h"

class VCal;
class Entry;

class OverviewDay : public VkComponent {
public:
  OverviewDay(char *name, Widget parent, VCal *owner);
  ~OverviewDay();

  const char *className();

  void setDate(int day, int month, int year,
	       Boolean isToday = False,
	       int start = 0,
	       int stop = MINS_IN_DAY);

protected:
  void display();
  void displayEntry(Entry *entry);
  void select();

  static void area_expose(Widget w, XtPointer client_data,
			  XtPointer call_data);
  static void area_input(Widget w, XtPointer client_data,
			 XtPointer call_data);

  VCal *owner;
  int day, month, year, start, stop;
  Dimension width, height;
  GC gcLabel, gcAnnotate;
  Boolean today;
};

#endif
