/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _PREF_DIALOG_
#define _PREF_DIALOG_

#include <Vk/VkPrefDialog.h>

class VCal;
class Preferences;
class VkPrefList;
class VkPrefGroup;
class VkPrefToggle;
class VkPrefText;
class VkPrefEmpty;

class PrefDialog : public VkPrefDialog {
  
public:
  
  PrefDialog(VCal *owner, Preferences *pref, const char *name);
  ~PrefDialog();
  
  void updateDisplay();

protected:
  virtual void apply(Widget, XtPointer);
  
  VCal *owner;
  VkPrefList *list;
  VkPrefGroup *day1, *day2, *day3, *config1, *config2, *config3;
  VkPrefGroup *alarmGroup, *alarmExtra, *dayGroup, *configGroup, *saveGroup;
  VkPrefText *filename, *advance, *update, *snooze;
  VkPrefToggle *lates, *autoSave, *annotate;
  VkPrefToggle *updateIcon, *updateIconDate, *clock24;
  VkPrefGroup *alarm1, *alarm2, *alarm3;
  VkPrefToggle *notifyPopup, *notifyBell, *notifyMail, *notifyConfirmDelete;
  VkPrefText *notifyCommand;
  VkPrefToggle *alarms;
  VkPrefToggle *annotateDay, *hideMenu;
  VkPrefToggle *annotateMonth, *restricted;
  VkPrefText *apptLength, *gridLength, *apptSubdiv, *snapInterval;
  VkPrefText *restrictStart, *restrictStop;

  VkPrefEmpty *space1, *space2, *space3;
  Preferences *pref;
};

#endif
