/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _PREFERENCES_
#define _PREFERENCES_

#include <X11/Intrinsic.h>

class Preferences {
public:
  Preferences(Widget w);
  ~Preferences();

  char *filename() { return _filename; }
  char *advanceWarning() { return _advanceWarning; }
  int updateInterval() { return _updateInterval; }
  Boolean showLates() { return _showLates; }
  Boolean saveChangesAutomatically() { return _saveChangesAutomatically; }
  Boolean annotateFile() { return _annotateFile; }
  Boolean updateIconName() { return _updateIconName; }
  Boolean updateIconDate() { return _updateIconDate; }
  Boolean clock24() { return _clock24; }
  Boolean alarms() { return _alarms; }
  Boolean notifyPopup() { return _notifyPopup; }
  Boolean notifyBell() { return _notifyBell; }
  Boolean notifyMail() { return _notifyMail; }
  Boolean notifyConfirmDelete() { return _notifyConfirmDelete; }
  char *notifyCommand() { return _notifyCommand; }
  Boolean annotateDay() { return _annotateDay; }
  int snoozeMinutes() { return _snoozeMinutes; }
  Boolean hideMenuBar() { return _hideMenuBar; }
  int apptLength() { return _apptLength; }
  int gridLength() { return _gridLength; }
  int apptSubdiv() { return _apptSubdiv; }
  int snapInterval() { return _snapInterval; }
  Boolean annotateMonth() { return _annotateMonth; }
  Boolean restricted() { return _restricted; }
  int restrictStart() { return _restrictStart; }
  int restrictStop() { return _restrictStop; }

  void setFilename(const char *v);
  void setAdvanceWarning(const char *v);
  void setUpdateInterval(int v) { _updateInterval = v; }
  void setShowLates(Boolean v) { _showLates = v; }
  void setSaveChangesAutomatically(Boolean v)
    { _saveChangesAutomatically = v; }
  void setAnnotateFile(Boolean v) { _annotateFile = v; }
  void setUpdateIconName(Boolean v) { _updateIconName = v; }
  void setUpdateIconDate(Boolean v) { _updateIconDate = v; }
  void setClock24(Boolean v) { _clock24 = v; }
  void setAlarms(Boolean v) { _alarms = v; }
  void setNotifyPopup(Boolean v) { _notifyPopup = v; }
  void setNotifyBell(Boolean v) { _notifyBell = v; }
  void setNotifyMail(Boolean v) { _notifyMail = v; }
  void setNotifyConfirmDelete(Boolean v) { _notifyConfirmDelete = v; }
  void setNotifyCommand(const char *v);
  void setAnnotateDay(Boolean v) { _annotateDay = v; }
  void setSnoozeMinutes(int v) { _snoozeMinutes = v; }
  void setHideMenuBar(Boolean v) { _hideMenuBar = v; }
  void setApptLength(int v) { _apptLength = v; }
  void setGridLength(int v) { _gridLength = v; }
  void setApptSubdiv(int v) { _apptSubdiv = v; }
  void setSnapInterval(int v) { _snapInterval = v; }
  void setAnnotateMonth(Boolean v) { _annotateMonth = v; }
  void setRestricted(Boolean v) { _restricted = v; }
  void setRestrictStart(int v) { _restrictStart = v; }
  void setRestrictStop(int v) { _restrictStop = v; }

  void loadPreferences();
  void savePreferences();

  void useFactory();

protected:
  char *_filename, *_filename0;
  char *_advanceWarning, *_advanceWarning0;
  int _updateInterval, _updateInterval0;
  Boolean _showLates, _showLates0;
  Boolean _saveChangesAutomatically, _saveChangesAutomatically0;
  Boolean _annotateFile, _annotateFile0;
  Boolean _updateIconName, _updateIconName0;
  Boolean _updateIconDate, _updateIconDate0;
  Boolean _clock24, _clock240;
  Boolean _alarms, _alarms0;
  Boolean _notifyPopup, _notifyPopup0;
  Boolean _notifyBell, _notifyBell0;
  Boolean _notifyMail, _notifyMail0;
  Boolean _notifyConfirmDelete, _notifyConfirmDelete0;
  char *_notifyCommand, *_notifyCommand0;
  Boolean _annotateDay, _annotateDay0;
  int _snoozeMinutes, _snoozeMinutes0;
  Boolean _hideMenuBar, _hideMenuBar0;
  int _apptLength, _apptLength0;
  int _gridLength, _gridLength0;
  int _apptSubdiv, _apptSubdiv0;
  int _snapInterval, _snapInterval0;
  Boolean _annotateMonth, _annotateMonth0;
  Boolean _restricted, _restricted0;
  int _restrictStart, _restrictStart0;
  int _restrictStop, _restrictStop0;
};

extern Preferences *thePreferences;

#endif
