/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _PRINT_PS_
#define _PRINT_PS_

#include <stdio.h>
#include <X11/Intrinsic.h>

class VCal;

class PrintPS {
public:
  PrintPS(VCal *owner);
  ~PrintPS();

  void printMonthUI(int month, int year);
  void printMonth(FILE *fd, int month, int year);

protected:
  void printHeader(FILE *fd);
  void emitWords(FILE *fd, char *str);
  void displayPrintUI(char *file);
  void printComplete();

  static void cancel_cb(Widget w, XtPointer client_data, XtPointer call_data);
  static void help_cb(Widget w, XtPointer client_data, XtPointer call_data);
  static void print_cb(Widget w, XtPointer client_data, XtPointer call_data);
  static void error_cb(Widget w, XtPointer client_data, XtPointer call_data);

  VCal *owner;
  char *printFile;
  Widget printBox;
};

#endif
