/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _TIME_INTERVAL_
#define _TIME_INTERVAL_

#include <Vk/VkComponent.h>

typedef enum TimeIntervalReason { TI_none, TI_deselect };

class TimeGrid;

class TimeInterval : public VkComponent {
public:
  TimeInterval(const char *name, TimeGrid *grid);
  ~TimeInterval();

  virtual const char* className();

  void setTimeInterval(int start, int length);
  void setCallback(XtCallbackProc proc, XtPointer client_data);

protected:
  void callCallback(TimeIntervalReason reason);

  static void button_press(Widget w, XtPointer client_data, XEvent *event,
			   Boolean *dispatch);

  Widget _form, _midSep, _startLabel, _endLabel;
  Dimension _labelHeight;
  TimeGrid *_grid;
  int _start, _length;
  XtCallbackProc _callback;
  XtPointer _callbackData;
};

#endif
