/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <stdio.h>
#include "TimeWeekdayEntry.h"
#include "TimeGrid.h"

static int count;
static Arg args[10];

TimeWeekdayEntry::TimeWeekdayEntry(const char *name, TimeGrid *grid, int w)
: TimeEntry(name, grid)
{
  _weekday = w;
}

TimeWeekdayEntry::~TimeWeekdayEntry()
{
}

const char *
TimeWeekdayEntry::className()
{
  return "TimeWeekdayEntry";
}

/**********************************************************************/

Boolean
TimeWeekdayEntry::reposition()
{
  Position x, y;
  Dimension width, height;

  if (_grid->requestWeekdayPosition(_start, _length, _weekday,
				    &x, &y, &width, &height)) {
    count = 0;
    XtSetArg(args[count], XmNx, x);  count++;
    XtSetArg(args[count], XmNy, y);  count++;
    XtSetArg(args[count], XmNwidth, width);  count++;
    XtSetArg(args[count], XmNheight, height);  count++;
    XtSetValues(_baseWidget, args, count);
    return True;
  } else {
    return False;
  }
}

void
TimeWeekdayEntry::select(Boolean)
{
  raise();
  callCallback(TE_selected);
}
