/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef _UTILS_
#define _UTILS_

#define DAYS_IN_WEEK		7
#define MAX_DAYS		6*DAYS_IN_WEEK
#define MINS_IN_HOUR		60
#define MINS_IN_DAY		(MINS_IN_HOUR*24)

#define MAXSTR	1024

void formatTime(int hour, int min, int clock24, char *str_return);
void formatShortTime(int hour, int min, char *str_return);
void formatDate(int weekday, int day, int month, int year, char *str_return);
void formatDate(int day, int month, int year, char *str_return);
void formatDate(int month, int year, char *str_return);
int readInt(FILE *fd, int *num);
void writeInt(FILE *fd, int num, char *annotation = NULL);
int readStr(FILE *fd, char *str_return);
void writeStr(FILE *fd, char *str);
int parseDate(char *str, int *day, int *month, int *year);
int parseMonth(char *str, int *month, int *year);
int compareDates(int day1, int month1, int year1,
		 int day2, int month2, int year2);
int computeWeekday(int day, int month, int year);
int computeDayDifference(int day1, int month1, int year1,
			 int day2, int month2, int year2);
void augmentDate(int day, int month, int year, int days,
		 int *day_return, int *month_return, int *year_return);
void decrementDate(int day, int month, int year, int days,
		   int *day_return, int *month_return, int *year_return);
int matchMonthString(char *str);
char *monthString(int month);
char *weekdayString(int day);

int jan1(int year);
int FirstDay(int month, int year);
int NumberOfDays(int month, int year);

#endif
