/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
////////////////////////////////////////////////////////
//  Attributes.h --
////////////////////////////////////////////////////////
#ifndef ATTRIBUTES_H
#define ATTRIBUTES_H

#include "OkToggleButton.h"

class Attributes;

class AttributeToggle : public OkToggleButton {

 private:
  Attributes*   _parent;

 public:
  AttributeToggle( const char* name, Widget, Attributes* parent );
  ~AttributeToggle() {}

  void valueChanged( Boolean );
};


class CardView;

#define ATTR_COUNT 4

class Attributes : public OkComponent {

 friend class CardView;
 friend class AttributeToggle;

 private:
  AttributeToggle*	_attributeToggles[ ATTR_COUNT ];
  CardView*		_parentView;

  Boolean		_radioStyle;
  Widget		_radioRowColumn;
  Widget		_rowColumn;

 public:
  Attributes( const char* name, Widget parent );
  ~Attributes();
  const char* className() { return "Attributes"; }

  void setRadioStyle( Boolean b=TRUE );
  void setAttrLabel( int i, const char* label );
  void hideAttr( int i );
  void showAttr( int i );

};


#endif
