/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//////////////////////////////////////////////////////////////////
// Buttons.h --
//////////////////////////////////////////////////////////////////
#ifndef BUTTONS_H
#define BUTTONS_H

#include "OkPushButton.h"


class ShowBtn : public OkPushButton {

 public:
  ShowBtn( Widget parent ) : OkPushButton( "showBtn", parent ) {}
  ~ShowBtn() {}

  void activate();

};

class DeleteBtn : public OkPushButton {

 public:
  DeleteBtn( Widget parent ) : OkPushButton( "deleteBtn", parent ) {}
  ~DeleteBtn() {}

  void activate();
};

class NewBtn : public OkPushButton {

 public:
  NewBtn( Widget parent ) : OkPushButton( "newBtn", parent ) {}
  ~NewBtn() {}

  void activate();
};


//////////////////////////////////////////////////////////
// Card View controls.
//////////////////////////////////////////////////////////

class CardView;

class FirstBtn : public OkPushButton {

 private:
  CardView*	_parentView;

 public:
  FirstBtn( Widget, CardView* );
  ~FirstBtn() {}

  void activate();
};




class PrevBtn : public OkPushButton {

 private:
  CardView*	_parentView;

 public:
  PrevBtn( Widget, CardView* );
  ~PrevBtn() {}

  void activate();
};




class NextBtn : public OkPushButton {

 private:
  CardView*	_parentView;

 public:
  NextBtn( Widget, CardView* );
  ~NextBtn() {}

  void activate();
};


class LastBtn : public OkPushButton {

 private:
  CardView*	_parentView;

 public:
  LastBtn( Widget, CardView* );
  ~LastBtn() {}

  void activate();
};


class CloseBtn : public OkPushButton {

 private:
  CardView*	_parentView;

 public:
  CloseBtn( Widget, CardView* );
  ~CloseBtn() {}

  void activate();
};



class SrchBtn : public OkPushButton {

 private:
  CardView*	_parentView;

 public:
  SrchBtn( CardView* );
  ~SrchBtn() {}

  void activate();
};

#endif
