/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
////////////////////////////////////////////////////////////////////////
// CardList.h --
////////////////////////////////////////////////////////////////////////
#ifndef CARDLIST_H
#define CARDLIST_H

#include "OkScrolledList.h"
#include "OkText.h"
#include "OkStrArray.h"

class CardList : public OkScrolledList {

 private:
  // Misc.
  static void selectPosProc( Widget, int, Boolean, caddr_t ); 
  static void deselectAllProc( Widget w, caddr_t obj );

  // Binary add.
  unsigned add( OkStr& s, unsigned, unsigned );

 public:
  CardList( Widget parent, OkStrArray& items, Widget srchText );
  ~CardList();
  const char* className() { return "CardList"; }

  void singleSelection();
  void extendedSelection() { singleSelection(); }
  void multipleSelection() { singleSelection(); }
  void browseSelection()   { singleSelection(); }

  void defaultAction();

  // Add s to list in sorted order.  Returns item position.
  unsigned add( OkStr s );
};

#endif
