/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//////////////////////////////////////////////////////////////////////
// GeneralPrefs.h --
//////////////////////////////////////////////////////////////////////
#ifndef GENERALPREFS_H
#define GENERALPREFS_H

#include "OkFileItem.h"

#include <Vk/VkPrefDialog.h>
#include <Vk/VkPrefItem.h>

#include <stdlib.h>

class GeneralPrefDialog : public VkPrefDialog, public OkFileItem {

 private:
  VkPrefText*	_defRolodexLoc;
  VkPrefText*	_faceImgLoc;

  VkPrefToggle* _showFaceImg;
  VkPrefToggle* _alwaysUseIntrDialog;

 protected:
  Widget createDialog(Widget);


 public:
  GeneralPrefDialog();
  ~GeneralPrefDialog() {}

  const char* defRolodexLoc() const;
  const char* faceImgLoc() const;
  Boolean showFaceImg() const		{ return _showFaceImg->getValue(); }

  Boolean alwaysUseIntrDialog() const   
				{ return _alwaysUseIntrDialog->getValue(); }


};
  

#endif
