/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//////////////////////////////////////////////////////////////////
// Print.h
//////////////////////////////////////////////////////////////////
#ifndef PRINT_H
#define PRINT_H

#include "VkPrintDialog.h"
#include "OkToggleButton.h"
#include "OkLabel.h"
#include "OkStr.h"



class CardView;
class RolodexInfoToggle;
class NotesToggle;

class PrintCardDialog : public VkPrintDialog {

 friend RolodexInfoToggle;
 friend NotesToggle;

 private:
  OkLabel*		_label;
  RolodexInfoToggle*	_rolodexInfoToggle;
  NotesToggle*		_notesToggle;

  OkStr			_printLabel;
  OkStr			_printBuf;

  const CardView*	_view;

  void composeRolodexInfo();
  void composeNotes();
  void toggleValuesChanged();

 protected:
  Widget createWorkArea( Widget parent );

 public:
  PrintCardDialog();
  ~PrintCardDialog() {}

  void printCardView( const CardView* view=NULL );

};



class RolodexInfoToggle : public OkToggleButton {

  void valueChanged( Boolean );

 public:
  RolodexInfoToggle( Widget parent ) : 
    OkToggleButton( "rolodexInfoToggle", parent ) {}

};

class NotesToggle : public OkToggleButton {

  void valueChanged( Boolean );

 public:
  NotesToggle( Widget parent ) : 
    OkToggleButton( "notesToggle", parent ) {}

};

//////// Print Global dialog
extern PrintCardDialog* thePrintCardDialog;

#endif
