/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//////////////////////////////////////////////////////////////////////
// SetupAttributes.h --
//////////////////////////////////////////////////////////////////////
#ifndef SETUPATTRIBUTES_H
#define SETUPATTRIBUTES_H

#include "Database.h"
#include "Attributes.h"

#include <Vk/VkPrefDialog.h>
#include <Vk/VkPrefItem.h>

#include <stdlib.h>


class SetupAttributes : public VkPrefDialog, public Persistent {

 private:
  IntKey	_key;

  VkPrefToggle*	_someOfMany;
  VkPrefToggle*	_oneOfMany;
  VkPrefToggle* _showAttr[ ATTR_COUNT ];
  VkPrefText*	_attrLabel[ ATTR_COUNT ];


 protected:
  void Read();
  void Write();

  Widget createDialog(Widget);

 public:
  SetupAttributes();
  ~SetupAttributes();

  Boolean radioStyle() const		{ return _oneOfMany->getValue(); }
  Boolean showAttr( int i ) const	{ return _showAttr[ i ]->getValue(); }
  const char* attrLabel( int i ) const 	{ return _attrLabel[ i ]->getValue(); }

  void save();
  void setFactoryDefault();
};

extern SetupAttributes* theSetupAttributes;

#endif
