/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/////////////////////////////////////////////////////////////////////////
// SrchDialog.h --
/////////////////////////////////////////////////////////////////////////
#ifndef SRCHDIALOG_H
#define SRCHDIALOG_H

#include "OkStr.h"
#include "OkText.h"
#include "OkLabeledComponent.h"
#include "OkToggleButton.h"

#include <Vk/VkGenericDialog.h>

class VkSimpleWindow;

class SrchDialog : public VkGenericDialog {

 private:
  OkLabeledComponent<OkText>*	_srchString;
  OkToggleButton*		_caseSensitive;
  OkToggleButton*		_srchNotes;

  void ok( Widget, XtPointer ) { srchForward(); }
  void apply( Widget, XtPointer ) { srchBackward(); }
  void cancel( Widget, XtPointer ) { unpost(); }

  void srchForward();
  void srchBackward();

  VkSimpleWindow* 	_currentParentWindow;
  Boolean	 	_allowInterruption;

 public:
  SrchDialog();
  ~SrchDialog() {}
  Widget createDialog( Widget );

  const char* srchString() const	{ return _srchString->t()->getValue(); }
  Boolean caseSensitive() const 	{ return _caseSensitive->getValue(); }
  Boolean srchNotes() const 		{ return _srchNotes->getValue(); }

  Boolean allowInterruption() const 	{ return _allowInterruption; }

  Widget prepost ( const char      *message,
                             XtCallbackProc   okCB       = NULL,
                             XtCallbackProc   cancelCB   = NULL,
                             XtCallbackProc   applyCB    = NULL,
                             XtPointer        clientData = NULL,
                             const char      *helpString = NULL,

                             VkSimpleWindow  *parent     = NULL);


};

extern SrchDialog* theSrchDialog;

#endif
