/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
// main.c++

#include "XContact.h"
#include "OkStr.h"

#include <iostream.h>

void Usage( const char* appName )
{
  cerr << "Usage: " << appName << " [-h|<contact book name>]" << endl;
  exit( -1 );
}


int main( int argc, char** argv )
{
  char* bookName=NULL;
  if ( argc>1 ) {

    // Syntax Help?
    if ( argc!=2 || OkStr( argv[ 1 ] ) == "-h" )
      Usage( argv[ 0 ] );

    bookName = argv[ 1 ];
    argc--;
  }

  XContact *app = new XContact( &argc, argv, bookName );
  assert( app );

  app->run();
}

